{
ZWECK       : Demo Netzwerkkommunikation ber MailSlots

DATEIEN     : ms02.dpr
              ms02u1.pas
              ms02u1.dfm

STAND       : 11.4.97

AUTOR       : Kurt Spitzley, email 0225438-0001@t-online.de

COPYRIGHT   : (c) 1997 bei Kurt Spitzley, All rights reserved.
              Diese Software darf zu nichtkommerziellen Zwecken frei genutzt
              und weitergegeben werden. Kommerzielle Nutzung nur mit ausdrck-
              licher Genehmigung des Autors.
GEWHR-
LEISTUNG    : Sie akzeptieren diese Software wie sie ist, ohne eine Garantie
              jeglicher Art, einschlielich aber nicht ausschlielich der
              Eignung fr eine beliebige Anwendung.

BESCHREIBUNG: Einfacher Mailslot-Client

================================================================================

SCOPE       : Demo Network-Communication via MailSlots

FILES       : ms02.dpr
              ms02u1.pas
              ms02u1.dfm

LAST CHANGES: 11.4.97

AUTHOR      : Kurt Spitzley, email 0225438-0001@t-online.de

COPYRIGHT   : (c) 1997 by Kurt Spitzley, All rights reserved.
              This software should not be SOLD by anyone. It is distributed as
              freeware and therefore may be used free of charge.

DISCLAIMER  : You accept this software AS IS without any representation or
              warranty of any kind, including but not limited to the warranty of
              merchantability or fitness for a particular purpose.

DESCRIPTION:  Simple Mailslot-Client
}

unit ms02u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Debwin, StdCtrls, ExtCtrls;

type
  EMailSlotError = class( Exception );

  TfrmMailslotDemo = class(TForm)
    gbPutIntoMailslot: TGroupBox;
    edPutIntoMailslot: TEdit;
    btnPutIntoMailslot: TButton;
    lblTxMailToSend: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnPutIntoMailslotClick(Sender: TObject);
  private
    MsgID: word;
    hMailSender: THandle;
  public
    { Public-Deklarationen }
  end;

var
  frmMailslotDemo: TfrmMailslotDemo;

implementation
       
{$R *.DFM}

procedure TfrmMailslotDemo.FormCreate(Sender: TObject);
begin
  MsgID:=0;

  // Create the mailslot file handle for sending messages

  hMailSender:=CreateFile('\\*\mailslot\MyMailSl',
                  GENERIC_WRITE,
                  FILE_SHARE_READ,
                  PSecurityAttributes(nil),
                  OPEN_EXISTING,
                  FILE_ATTRIBUTE_NORMAL,
                  0);
  if hMailSender=INVALID_HANDLE_VALUE then
    raise EMailSlotError.Create('Error creating Mailslot File');
end;

procedure TfrmMailslotDemo.FormDestroy(Sender: TObject);
begin
  CloseHandle(hMailSender);
end;

procedure TfrmMailslotDemo.btnPutIntoMailslotClick(Sender: TObject);
var
  Status: boolean;
  TextToSend: string;
  NumBytesWritten: dword;
begin
  // Write message to mailslot
  inc(MsgID);
  TextToSend:=format('Mail-ID: %d Mail: %s',[MsgID,edPutIntoMailslot.Text]);
  Status:=WriteFile(hMailSender,
                    pchar(TextToSend)^,
                    length(TextToSend),
                    NumBytesWritten,
                    nil);
end;
         
end.

