{
ZWECK       : Demo MailSlot-Komponente TMailslot

DATEIEN     : test.dpr
              test1.pas
              test1.dfm

STAND       : 19.4.97

AUTOR       : Kurt Spitzley, email 0225438-0001@t-online.de

COPYRIGHT   : (c) 1997 bei Kurt Spitzley, All rights reserved.
              Diese Software darf zu nichtkommerziellen Zwecken frei genutzt
              und weitergegeben werden. Kommerzielle Nutzung nur mit ausdrck-
              licher Genehmigung des Autors.
GEWHR-
LEISTUNG    : Sie akzeptieren diese Software wie sie ist, ohne eine Garantie
              jeglicher Art, einschlielich aber nicht ausschlielich der
              Eignung fr eine beliebige Anwendung.

BESCHREIBUNG: Demonstriert die Anwendung der TMailslot-Komponente

================================================================================

SCOPE:      : Demo MailSlot-Component TMailslot

FILES:      : test.dpr
              test1.pas
              test1.dfm

LAST CHANGES: 19.4.97

AUTHOR      : Kurt Spitzley, email 0225438-0001@t-online.de

COPYRIGHT   : (c) 1997 by Kurt Spitzley, All rights reserved.
              This software should not be SOLD by anyone. It is distributed as
              freeware and therefore may be used free of charge.

DISCLAIMER  : You accept this software AS IS without any representation or
              warranty of any kind, including but not limited to the warranty of
              merchantability or fitness for a particular purpose.

DESCRIPTION:  Demonstrates usage of TMailslot-Component
}

unit test1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Debwin, StdCtrls, ExtCtrls, Mailslot;

type
  TfrmMailslotDemo = class(TForm)
    gbPutIntoMailslot: TGroupBox;
    edPutIntoMailslot: TEdit;
    btnPutIntoMailslot: TButton;
    gbReadMailslot: TGroupBox;
    lboxReadMailslot: TListBox;
    btnReadMailslot: TButton;
    edClientMachineOrDomain: TEdit;
    edClientMailslotName: TEdit;
    lblTxDomainMachine: TLabel;
    lblTxMailslotName: TLabel;
    lblMailToSend: TLabel;
    lblRxMailslotName: TLabel;
    edServerMailslotName: TEdit;
    cbActivateOnMailEvent: TCheckBox;
    btnClearListbox: TButton;
    cbAllowDuplicateMails: TCheckBox;
    btnSetDomainOrMachineAndMailslot: TButton;
    btnSetMailslotName: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnPutIntoMailslotClick(Sender: TObject);
    procedure btnReadMailslotClick(Sender: TObject);
    procedure cbActivateOnMailEventClick(Sender: TObject);
    procedure btnClearListboxClick(Sender: TObject);
    procedure cbAllowDuplicateMailsClick(Sender: TObject);
    procedure btnSetMailslotNameClick(Sender: TObject);
    procedure btnSetDomainOrMachineAndMailslotClick(Sender: TObject);
  private
    FMailslotServer: TMailslotServer;
    FMailslotClient: TMailslotClient;
    procedure OnMail(Sender:TObject; Mail:string);
  public
  end;

var
  frmMailslotDemo: TfrmMailslotDemo;

implementation

{$R *.DFM}                 

procedure TfrmMailslotDemo.OnMail(Sender:TObject; Mail:string);
begin
  lboxReadMailslot.Items.Add('<'+Mail+'>');
end;

procedure TfrmMailslotDemo.FormCreate(Sender: TObject);
begin

  // Create a Mailslot for receiving mails

  FMailslotServer:=TMailslotServer.Create(self,edServerMailslotName.Text);

  // Create the Mailslot file handle for sending mails

  FMailslotClient:= TMailslotClient.Create(self,edClientMachineOrDomain.Text,
                                                edClientMailslotName.Text);
end;

procedure TfrmMailslotDemo.btnPutIntoMailslotClick(Sender: TObject);
begin
  FMailslotClient.WriteString(edPutIntoMailslot.Text); // Write mail to Mailslot
end;

procedure TfrmMailslotDemo.btnReadMailslotClick(Sender: TObject);
begin
  if FMailslotServer.MailAvailable then
    lboxReadMailslot.Items.Add('<'+FMailslotServer.ReadString+'>');
end;

procedure TfrmMailslotDemo.cbActivateOnMailEventClick(Sender: TObject);
begin
  if cbActivateOnMailEvent.Checked then
    FMailslotServer.OnMail:=OnMail
  else
    FMailslotServer.OnMail:=nil;
end;

procedure TfrmMailslotDemo.btnClearListboxClick(Sender: TObject);
begin
  lboxReadMailslot.Clear;
end;

procedure TfrmMailslotDemo.cbAllowDuplicateMailsClick(Sender: TObject);
begin
  FMailslotServer.AllowDupMsgs:=cbAllowDuplicateMails.Checked;
end;

procedure TfrmMailslotDemo.btnSetMailslotNameClick(Sender: TObject);
begin
  FMailslotServer.Mailslot:=edServerMailslotName.Text;
end;

procedure TfrmMailslotDemo.btnSetDomainOrMachineAndMailslotClick(
  Sender: TObject);
begin
  FMailslotClient.MachineOrDomain:=edClientMachineOrDomain.Text;
  FMailslotClient.Mailslot:=edClientMailSlotName.Text;
end;

end.

